sprite = {}

function set_perk(mode,id)
	local x=player(id,"x")
	local y=player(id,"y")
	if mode == "blue" then
		glow("bluetop","gfx/sprites/flare2.bmp",200,id,000,000,255,1,.5,.5)
		glow("blueorb","gfx/gui_load.bmp",100,id,0,0,255,1,1,2.3,2000,7)
		timer(200,"parse",'lua "trail('..(1)..','..id..','..(0)..','..(0)..','..(255)..')"',0)
	elseif mode == "red" then
		glow("redtop","gfx/flare2.bmp",200,id,255,000,000,1,.5,.6)
		glow("fireball2","gfx/mapart/fireball2.png",100,id,255,0,000,1,1,1.4,3000,5)
		glow("fireball","gfx/mapart/fireball.png",100,id,255,0,000,1,1,1.4,3000,-8)
		timer(200,"parse",'lua "trail('..(2)..','..id..','..(0)..','..(0)..','..(255)..')"',0)
	end
end

addhook("die","gfx_die")
function gfx_die(id)
	clearperk(id)
end

function glow(iid,location,position,id,r,g,b,blend,alpha,scale,fadespeed,rotspeed,cr,cg,cb,cspeed,rot)
	sprite[id][iid] = image(location,0,0,position+id)
	imagecolor(sprite[id][iid],r,g,b)
	imageblend(sprite[id][iid],blend)
	imagealpha(sprite[id][iid],alpha)
	imagescale(sprite[id][iid],scale,scale)
	if rot ~= nil then
		imagepos(sprite[id][iid],0,0,rot)
	end
	if fadespeed ~= nil then
		timer(fadespeed*2,"parse",'lua "fade('..sprite[id][iid]..','..(fadespeed)..')',0)
	end
	if rotspeed ~= nil then
		tween_rotateconstantly(sprite[id][iid],rotspeed)
	end
	if cspeed and cr and cb and cg ~= nil then
		timer(cspeed*2,"parse",'lua "color('..sprite[id][iid]..','..(cspeed)..','..(cr)..','..(cg)..','..(cb)..','..(r)..','..(g)..','..(b)..')',0)
	end
end

	function fade(i,speed)
		tween_alpha(i,speed,.2)
		timer(speed,"parse",'lua "tween_alpha('..i..','..(speed)..','..(.8)..')"',1)
	end

function trail(mode,id,r,g,b)
	local x=player(id,"x")
	local y=player(id,"y")
	if mode == 1 then
		parse('effect "flare" '..x..' '..y..' 2 20 '..r..' '..g..' '..b..'')
	elseif mode == 2 then
		parse('effect "fire" '..x..' '..y..' 2 20 '..r..' '..g..' '..b..'')
	elseif mode == 3 then
		parse('effect "smoke" '..x..' '..y..' 15 15 '..r..' '..g..' '..b..'')
	end
end

function clearperk(id)
	if user_gfx[id] == "blue" then
		freeimage(sprite[id]["bluetop"])
		freeimage(sprite[id]["blueorb"])
		freetimer("parse",'lua "trail('..(1)..','..id..','..(0)..','..(0)..','..(255)..')"')
		freetimer("parse",'lua "fade('..sprite[id]["blueorb"]..','..(2000)..')')
	end
	user_gfx[id] = "none"
end