--variables [mix]:
mix_on = false
mix_side = 1
mix_captain = {}
mix_captain_pick = {false,false}
mix_players_total = 0
mix_nodmg = false
mix_team = {{}},{{}}
--variables [vote]:
vote_total = 0
round_type = 0
--team stats
player_damage = {} player_voted = {}
for i = 1,32 do
	if i == 1 or i == 2 then
		mix_team[i]["stat"] = {damage=0,kills=0,deaths=0,wins=0,losses=0}
	end
	mix_team[1][i] = {score,deaths,money}
	mix_team[2][i] = {}
	player_voted[i] = false
	player_damage[i] = 0
end

------------settings:------------------------------
-----------------------------------------------------
vote_percent = 70 -- how much % of votes to start the mix.
freezetime = 5
startmoney = 800
switchtype = 1 --1 : switch @ first team to win #rounds, 2 : switch @ #rounds., 3 : switch @ first team to get switchkills kills.
switchmoney = 12000 -- average money per person.
switchkills = 30
rounds = 10
specmode = 0
taclimit = 30 --seconds for tactics. 0 to skip tactics.
fixedmoney = 0 -- switch to grater then 0 to enable players to get a fixed  X amount of money each round. (
reconnect_timer = 60 --how much time is given for a disconnected player to rejoin the mix.
votetimer = 20 --how long before vote is abandoned.
-----------------------------------------------------
-----------------------------------------------------
addhook("say","mix_say")
function mix_say(id,txt)
	local a = string.find(txt, "!mix")
	local b = string.find(txt, "!pick%s%d+")
	if a then
		if not mix_on and mix_countvote("mix",id) then
			msg(''..player(id,"name")..' votes for !mix. | %'..votes*100/#player(0,"table")..'/100')
		else
			msg2(id,'ERROR : a mix has already been started')
		end
		return 1
	elseif b then
		if id == mix_captain[player(id,"team")] and mix_captain_pick[player(id,"team")] == true then
			if #mix_team[1] == 0 and #mix_team[2] == 1 then
				parse('maket '..string.gmatch('!pick%s(%d+)')..'')
				mix_roundtype = 1
				parse('restart')
			elseif #mix_team[1] == 0 and #mix_team[2] == 1 then
				parse('makect '..string.gmatch('!pick%s(%d+)')..'')
				parse('restart')
			end
		elseif mix_countvote("captain",id,string.gmatch('!pick%s(%d+)')) then
			if #mix_team[2]+#mix_team[1] == 2 then
				mix_roundtype = 1
				parse('restart')
			end
		end
		return 1
	elseif c then
	end
end

function mix_countvote(mode,id,taget)
	if mode == "mix" then
		if not player_voted[id] then
			player_voted[id] = true
			vote_total = vote_total+1
		else
			return false
		end
		if vote_total >= vote_percent*(#player(0,"table")/100) then
			mix_start()
		end
	end
	return 0
end

function mix_start()
	msg('A mix has been started!@C')
	mix_specall()
	mix_on = true
end

function mix_showrules()
	msg('--RULES--:')
	msg('freezetime : '..freezetime..'')
	msg('roundtime : '..freezetime..'')
	if fixedmoney>0 then
		msg('startmoney : auto : '..fixedmoney..'')
	else
		msg('startmoney : '..startmoney..'')
	end
	if switchtype == 1 then
		msg('#1 : Switch at first team to win '..rounds..' rounds.')
	elseif switchtype == 2 then
		msg('#2 : Switch after '..rounds..' rounds.')
	elseif switchype == 3 then
		msg('#3 : Switch at first team to get '..switchkills..' kills.')
	end
	msg('tactical time : '..taclimit..'')
	msg('specmode : '..specmode..'')
end

function mix_setrules()
	parse('mp_freezetime '..freezetime..'')
	parse('mp_startmoney '..startmoney..'')
	parse('sv_specmode '..specmode..'')
end

function mix_specall()
	local playerlist=player(0,"table")
	for _,id in pairs(playerlist) do
		parse('makespec '..id..'')
	end
	parse('restart')
end

addhook("kill","mix_kill")
function mix_kill(killer,victim,weapon,x,y)
	kills[player(killer,"team")] = kills[player(killer,"team")]+1
	deaths[player(victim,"team")] = kills[player(victim,"team")]+1
end


addhook("hit","mix_hit")
function mix_hit(id,source,w,h,a,dmg)
	if mix_on then
		if mix_nodmg then
			return 1
		end
		if playerdamage[source] ~= nil then
			playerdamage[source] = playerdamage[source]+dmg
		else
			playerdamage[source] = dmg
		end
		damage[player(id,"team")] = damage[player(id,"damage")]+dmg
	end
	return 0
end

function mix_switch()
	if mix_side == 0 then 
		local wins_1 = wins[1]
		wins[1] = wins[2]
		wins[2] = wins_1
		for _,id in pairs(player(0,"table")) do
			if player(id,"team") == 1 then
				parse('makect '..id..'')
			elseif player(id,"team") == 2 then
				parse('maket '..id..'')
			end
		end
		mix_side = 1
		msg('Teams SWITCHED')
		parse('restart')
	else
		return false
	end
end

function mix_restartpause()
	parse('restart')
	for _,id in pairs(player(0,"table")) do
		if player(id,"team") > 0 then
			for i = 1,#stat do
				if player(id,"name") == stat[i][1] then
					parse('setmoney '..id..' '..stat[i][2]..' ')
					parse('setscore '..id..' '..stat[i][3]..' ')
					parse('setdeaths '..id..' '..stat[i][4]..' ')
					break
				elseif i == #stat then
					parse('makespec '..id..' ')
				end
			end
		end
	end
end

addhook("leave","mix_disconnect")
function mix_disconnect(id)
	if mix_on then
		if player(id,"team") == 1 or player(id,"team") == 2 then
			table.remove(mix_team[player(id,"team")],id)
		end
	end
end

function mix_bestplayer()
	currentbest = 0
	for _,id in pairs(player(0,"table")) do
		if player(id,"team") > 0 and playerdamage[id] ~= nil then
			if currentbest == 0 then
				currentbest = id
			elseif playerdamage[id] > playerdamage[currentbest] then
				currentbest = id
			end
		end
	end
	if playerdamage[currentbest] ~= nil then
		return (player(playerdamage[currentbest],"name"))
	else
		return ('ERROR')
	end
end

function mix_savestats()
	c = 1
	for _,id in pairs(player(0,"table")) do
		if player(id,"team") > 0 then
			stat[c][1] = player(id,"name")
			stat[c][2] = player(id,"money")
			stat[c][3] = player(id,"score")
			stat[c][4] = player(id,"deaths")
		end
		c = c+1
	end
end

function mix_pause()
	msg('game stats will pause in knife mode next round untill '..#idlers..' player(s) return within '..reconnect_timer..'@C')
	local playerlist=player(0,"table")
	for _,id in pairs(playerlist) do
		money[id][1] = player(id,"money")
		money[id][2] = player(id,"name")
	end
end

addhook("endround","mix_endround")
function mix_endround()
	msg('score ct : '..wins[2]..'/t : '..wins[1]..' ')
	msg('round best : '..(mix_bestplayer())..'')
	for i = 1,32 do
		playerdamage[i] = 0
	end
end

addhook("startround","mix_newround")
function mix_newround(mode)
	if mix_on then
		if mix_roundtype == 1 then
			mix_setround("tactical")
		elseif mix_roundtype == 2 and not  finish_idleound then
			mix_setround("knife")
		else
			finish_idleround = false --turn off idleround incase next round
			mix_savestats()
			mix_scoreteam(mode)
			if mix_roundtype(switchtype) == false then
				mix_end()
			end
		end
	end
end

function mix_scoreteam(mode)
	if mode == 1 or mode == 20 then
		wins[1] = wins[1]+1
	elseif mode == 2 or mode == 21 then
		wins[2] = wins[2]+1
	end
end

addhook("team","mix_join")
function mix_join(id,team,look)
	if mix_on then
		if player(id,"team") == 0 and mix_on then
			if #mix_team[team] == 0 then
				mix_captain[team] = player(id,"name")
				mix_team[team][#mix_team+1] = player(id,"name")
				return 0
			elseif #mix_team[1]+#mix_team[2] == 2 then
				parse('restart')
				local playerlist=player(0,"table")
				mix_setround("knife")
				msg('Knife round started. winner chooses team.')
				parse('mp_roundtime 1')
			else
				for i =1,#mix_team[team] do
					if mix_team[team][i] ==  player(id,"name") then
						return 0
					end
				end
				return 1
			end
		end
	end
end

function mix_setround(mode)
	if mode == "knife" then
		parse('setmoney '..id..' 0')
		local playerlist=player(0,"table")
		for _,id in pairs(playerlist) do
			parse('strip '..id..'')
		end
	elseif mode == "tactical" then
		msg('Knife Round@C')
		mix_nodmg = true
	elseif mode == 1 then
		if wins[1]+wins[2] >= rounds then
			if not mix_switch() then 
				return false
			end
		end
	elseif mode == 2 then
		if wins[1] >= rounds or wins[2] >= rounds then
			if not mix_switch() then 
				return false
			end
		end
	elseif mode == 3 then
		local teammoney = {0,0,0}
		for _,id in pairs(player(0,"table")) do
			teammoney[player(id,"team")] = teammoney[player(id,"team")] + player(id,"money")
		end
		teammoney[1] = teammoney[1]/#player(0,"team1")
		teammoney[2] = teammoney[2]/#player(0,"team2")
		if teammoney[1] >= switchmoney or teammoney[2] >= switchmoney then
			if not mix_switch() then 
				return false
			end
		end
	elseif mode == 4 then
		local teamkills = {0,0,0}
		for _,id in pairs(player(0,"table")) do
			teamkills[player(id,"score")] = teamkills[player(id,"score")] + player(id,"score")
		end
		if teamkills[1] >= switchkills or teamkills[2] >= switchkills then
			if not mix_switch() then 
				return false
			end
		end
	end
end